<?php

/* 
 * Admin menu for OJS ELiS integration
 * @author Arsen I. Borovinskiy
 */

function elis_ojs_admin_settings_form($form) {
    
  $default_value = variable_get('elis_ojs_settings', false);
  if ($default_value != false) {
    $default_value = json_encode($default_value); // object to string
  }
  $form['elis_ojs_settings_json'] = array(
    '#type' => 'textarea',
    '#title' => 'Настрйоки OJS в формате JSON',
    '#required' => FALSE,
    '#default_value' => $default_value,
    '#description' => 'Должна быть валидная конфигурация в формате JSON со списком нод для импорта. Пример: {"nodes":[{"nid":12345},{"nid":54321}]}',
  );
  $form['submit'] = array(
    '#type' => 'submit',
    '#value' => 'Submit',
  );
  return $form;
}

function elis_ojs_admin_settings_form_validate($form,&$form_state) {
  $form_state['cache'] = FALSE;
  if ($form_state['values']['elis_ojs_settings_json'] != false && strlen($form_state['values']['elis_ojs_settings_json']) > 0) {
    try {
      $json = json_decode($form_state['values']['elis_ojs_settings_json']);
      if (is_object($json)) {
        if (!isset($json->nodes)) {
          form_set_error('elis_ojs_settings_json', 'json must need have "nodes" array with object strcture {"nid":*}. Example {"nodes":[{"nid":"1234"},{"nid":"4321"}]}');
        }
      }
    } catch (Exception  $e) {
      form_set_error('elis_ojs_settings_json', 'JSON parse error: ' . $e->getMessage());
    }
  }
}

function elis_ojs_admin_settings_form_submit($form,$form_state) {
  $json = json_decode($form_state['values']['elis_ojs_settings_json']);
  variable_set('elis_ojs_settings', $json); // save as php object
}