<?php


/**
 * Implements hook_drush_command().
 */
function elis_ojs_drush_command() {

  $items = array();
  $items['elis-ojs-import'] = array(
    'callback' => 'import_ojs_elis',  // Callback function
    'description' => 'Import resources from Open Journal System.',
    'arguments' => array(
    ),
    'options' => array(
      'url' => 'URL of journal in OJS',
      'nid' => 'Root node nid that root folder of OJS for import journal catalog tree.',
      'from' => 'Y-m-d of start date for import. Example: --from=2022-01-01',
      'until' => 'Y-m-d of end date for import. Example: --until=2022-01-01',
      'sync' => 'Sync exists nodes (imported before). Example: --sync=1. Default: --sync=0'
    ),
    'aliases' => array('ojs'), // alias of command
    'examples' => array(      // List these example when user types : drush help nc
      'Import resources from https://ntb.gpntb.ru/jour to https://elis.example.com/node/12345' => 'drush ojs --url=https://ntb.gpntb.ru/jour --nid=12345',
    ),
  );
  return $items;
}

function import_ojs_elis() {
  set_php_admin_memory_limit();
  module_load_all();
  $journalUrl = drush_get_option('url');
  $rootNid = drush_get_option('nid');
  //$journalNode = node_load($rootNid);
  $from = drush_get_option('from');
  $until = drush_get_option('until');
  $sync = drush_get_option('sync');
  $elisImportOjs = new ElisImportOjs($rootNid);
  if ($from != null && $until != null && preg_match("/^\d\d\d\d-\d\d?-\d\d?$/",$from) && preg_match("/^\d\d\d\d-\d\d?-\d\d?$/", $until)) {
    $elisImportOjs->from = $from;
    $elisImportOjs->until = $until;
  }
  if (isset($sync)) {
    $elisImportOjs->sync = ($sync == '1') ? true : false;
  }
  $elisImportOjs->importJournal();
  //$elisImportOjs->importFromJournalUrl($journal_url, $root_nid);
  //$elisImportOjs->importJournalFromIdentsFile($journal_url, node_load($root_nid));
  
}
